unit WaitForm;

{
  (c) 2011 by Paul TOTH <tothpaul@free.fr>
}

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TProcess = procedure of Object;

  TWait = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
    FProcess: TProcess;
    FThread : THandle;
    procedure ThreadProc;
    function Execute(Process: TProcess): TModalResult;
    procedure WMUser(var Msg: TMessage); message WM_USER;
  public
    { Dclarations publiques }
  end;

var
  Wait: TWait;

function Submit(Process: TProcess): TModalResult;

implementation

{$R *.dfm}

function Submit(Process: TProcess): TModalResult;
begin
  Result := mrNone;
  with TWait.Create(Application) do
  begin
    try
      Result := Execute(Process);
    finally
      Free;
    end;
  end;
end;

function StartMe(Sender: TWait): integer; stdcall;
begin
  try
    Sender.ThreadProc;
    Result := 0;
  except
    Result := -1;
  end;
end;

{ TWait }

function TWait.Execute(Process: TProcess): TModalResult;
var
  ThreadID: Cardinal;
begin
  FProcess := Process;
  IsMultiThread := True;
  FThread := CreateThread(nil, 0, @StartMe, Self, 0, ThreadID);
  if WaitForSingleObject(FThread, 2000) = WAIT_TIMEOUT then
    Result := ShowModal
  else
    Result := mrOK;
  CloseHandle(FThread);
end;

procedure TWait.ThreadProc;
begin
  FProcess;
  PostMessage(Handle, WM_USER, 0, 0);
end;

procedure TWait.WMUser(var Msg: TMessage);
begin
  ModalResult := mrOK;
end;

procedure TWait.Button1Click(Sender: TObject);
begin
  TerminateThread(FThread, 0);
  ModalResult := mrCANCEL;
end;

end.
